#include "systemc.h"

class Test: public sc_module {
public:
  SC_HAS_PROCESS(Test);
  sc_event request, acknowlege, end, event;

  void sender()
  {
    wait(request);

    acknowlege.notify(SC_ZERO_TIME);

    for(int i = 0; i < 10; i++) {

      send_data();
      event.notify(SC_ZERO_TIME);
      // Do some stuff
      wait(SC_ZERO_TIME);
    }

    wait(SC_ZERO_TIME);
    end.notify(SC_ZERO_TIME);
    wait(SC_ZERO_TIME);

  }

  void receiver()
  {

    request.notify(SC_ZERO_TIME);

    wait(acknowlege);

    for(int i = 0; i < 10; i++) {

      wait(event);
      receive_data();
      // Do some stuff
    }

    wait(end);

    compute_checksum();
  }

  void send_data()
  { }

  void receive_data()
  { }

  void compute_checksum()
  { }

  Test(sc_module_name mn):
    sc_module(mn)
  {
    SC_THREAD(sender);
    SC_THREAD(receiver);
  }
};

int sc_main(int argc, char **argv)
{
  Test t("test");
  sc_start();
  return 0;
}
