#include "hierarchical_channel.h"

#include "design.h"
#include "../tools/class_is_derived_from.h"

risc::HierarchicalChannel::HierarchicalChannel(SgClassDefinition *ast_node):
  Module(ast_node, HierarchicalChannelType),
  instance_counter_(0)
{ }

void
risc::HierarchicalChannel::print_hierarchical_channel_definition()
{
  print_module_definition();
}

std::list<risc::Interface*> risc::HierarchicalChannel::get_interfaces()
{
  std::list<risc::Interface*> result;

  for(SgBaseClassPtrList::const_iterator
      iter  = get_ast_node()->get_inheritances().begin();
      iter != get_ast_node()->get_inheritances().end();
      iter++) {

    SgClassDefinition *derived_class
      = (*iter)->get_base_class()->get_definition();

    if(tools::is_derived_from_sc_interface(derived_class)) {
      result.push_back(risc::get_design()->find_interface(derived_class));
    }
  }

  return result;
}

/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
