#include "path_instance_mapper.h"

#include <assert.h>

#include "dynamic_internal_representation.h"

risc::PathInstanceMapper::PathInstanceMapper():
  max_instances_(0)
{ }

void
risc::PathInstanceMapper::print_mapping()
{
  for(std::vector<PathWithID>::iterator
      iter  = path_to_id_mapping_.begin();
      iter != path_to_id_mapping_.end();
      iter++) {

    std::cout << (*iter).second << ", ";
    (*iter).first.print_instance_tree();
  }
}

int risc::PathInstanceMapper::get_id(InstanceTree tree)
{
  assert("This function should only be used with an StaticInstanceMapper object" && 0);
  return 0;
}

risc::InstanceTree
risc::PathInstanceMapper::get_instance_tree(
    int id,
    std::list<InstanceTree> potential_instances)
{
  assert("This function should only be used with an StaticInstanceMapper object" && 0);
  risc::InstanceTree dummy;
  return dummy;
}

DynamicModule*
risc::PathInstanceMapper::get_dynamic_tree_root()
{
  assert("This function should only be used with an DynamicInstanceMapper object" && 0);
  return 0;
}

int*
risc::PathInstanceMapper::get_global_variable_address(std::string variable_name)
{
  assert("This function should only be used with an DynamicInstanceMapper object" && 0);
  return 0;
}

std::string risc::PathInstanceMapper::get_global_variable_name(int *variable_address)
{
  assert("This function should only be used with an DynamicInstanceMapper object" && 0);
  return "";
}
