#ifndef PORT_CALL_ATTRIBUTE_H_INCLUDED_
#define PORT_CALL_ATTRIBUTE_H_INCLUDED_

#include "rose.h"
#include "segment.h"

#include<set>

namespace risc {

namespace sg {

/**
 * \class PortCallAttribute
 * \brief This class stores for function calls
 */
class PortCallAttribute: public AstAttribute {

public:

  // for the new rose release
  virtual AstAttribute::OwnershipPolicy getOwnershipPolicy() const ROSE_OVERRIDE
  {
    return CONTAINER_OWNERSHIP;
  }

  std::list<Segment*> segment_ids_;

  PortCallAttribute();
};

} // end of namespace sg

} // end of namespace risc

#endif /* PORT_CALL_ATTRIBUTE_H_INCLUDED_ */

/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
