// data_conflict.cc:
//
// 07/02/18 RD  version now passes testing (for sc_time, sc_signal variables)
// 06/28/18 RD  initial version (class variables ignored in access analysis)

#include <stdio.h>
#include "systemc.h"

class Main : public sc_module
{
    public:
	int a1,a2,a3;
	double b1,b2,b3;
        sc_time t1,t2,t3;
        sc_signal<int> s1,s2,s3;

	void S1()
	{
		a1 = 42;
		b1 = a1 / 10.0;
                t1 = sc_time_stamp();
                s1 = 13;
                wait(1,SC_NS);
                t1 += SC_ZERO_TIME;
                wait(1,SC_NS);
                s1 = s2;
                wait(1,SC_NS);
                t1 = sc_time_stamp();
	}

	void S2()
	{
		a2 = 42;
		b2 = a2 / 10.0;
                t2 = sc_time_stamp();
                s2 = 27;
                wait(1,SC_NS);
                t2 = t2;
                wait(1,SC_NS);
                s2 = s1;
                wait(1,SC_NS);
                t2 = sc_time_stamp();
	}

	void S3()
	{
		a3 = 42;
		b3 = a3 / 10.0;
                t3 = sc_time_stamp();
                s3 = 13;
                wait(1,SC_NS);
                t3 = t2;
                wait(1,SC_NS);
                s3 = s2;
                wait(1,SC_NS);
                t3 = sc_time_stamp();
	}

	Main(sc_module_name name)
	: sc_module(name)
	{
		a1=0;
		a2=0;
		a3=0;
		b1=0.0;
		b2=0.0;
		b3=0.0;
                t1=SC_ZERO_TIME;
                t2=SC_ZERO_TIME;
                t3=SC_ZERO_TIME;
                s1=0;
                s2=0;
                s3=0;
		SC_THREAD(S1);
		SC_THREAD(S2);
		SC_THREAD(S3);
	}
	SC_HAS_PROCESS(Main);
};

int sc_main(int argc, char* argv[])
{
    Main m("m");
    const sc_time t1(3, SC_NS);
    const sc_time t2(3, SC_NS);
    const sc_time t3(3, SC_NS);

    printf("data_conflict starts\n");
    sc_start();
    cout << m.a1 << " at " << m.t1.to_string() << ", "
         << m.a2 << " at " << m.t2.to_string() << ", "
         << m.a3 << " at " << m.t3.to_string() << endl;
    assert(m.a1==42);
    assert(m.a2==42);
    assert(m.a3==42);
    assert(m.b1==4.2);
    assert(m.b2==4.2);
    assert(m.b3==4.2);
    assert(m.t1 == t1);
    assert(m.t2 == t2);
    assert(m.t3 == t3);
    assert(m.s1 == 27);
    assert(m.s2 == 13);
    assert(m.s3 == 27);
    printf("data_conflict done\n");
    return 0;
}

/* ex: set softtabstop=8 tabstop=8 shiftwidth=8 expandtab: */
