#include<iostream>
#include<string>
#include<assert.h>

#include "rose.h"
#include "risc.h"

using namespace SageBuilder;
using namespace SageInterface;

int main (int argc, char* argv[] )
{
  std::cout << std::endl
            << "START PROCESSING FILE: " __FILE__
            << " ..."
            << std::endl;


  risc::Design d(argc, argv);

  for(risc::ModuleVectorIter
      iter = d.module_definitions_.begin();
      iter != d.module_definitions_.end(); iter++) {

    std::cout << (*iter)->get_ast_type_name() << std::endl;
  }


  assert( risc::tools::class_types_are_identical(
    d.module_definitions_.at(0)->get_ast_node(),
    d.module_definitions_.at(0)->get_ast_node()));

  assert(! risc::tools::class_types_are_identical(
    d.module_definitions_.at(0)->get_ast_node(),
    d.module_definitions_.at(1)->get_ast_node()));

  assert(! risc::tools::class_types_are_identical(
    d.module_definitions_.at(0)->get_ast_node(),
    d.module_definitions_.at(2)->get_ast_node()));

  assert(! risc::tools::class_types_are_identical(
    d.module_definitions_.at(0)->get_ast_node(),
    d.module_definitions_.at(3)->get_ast_node()));

  assert(! risc::tools::class_types_are_identical(
    d.module_definitions_.at(0)->get_ast_node(),
    d.module_definitions_.at(4)->get_ast_node()));

  assert(! risc::tools::class_types_are_identical(
    d.module_definitions_.at(2)->get_ast_node(),
    d.module_definitions_.at(1)->get_ast_node()));

  assert( risc::tools::class_types_are_identical(
    d.module_definitions_.at(2)->get_ast_node(),
    d.module_definitions_.at(2)->get_ast_node()));

  std::cout << "END PROCESSING FILE: " __FILE__
            << " ..."
            << std::endl
            << std::endl;

  return 0;
}

/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
